<?php

//
// +-----------------------------------------------------------------------------+
// | Copyright (c) 2011 Nikitin Iliya aka Deep                                   |
// +-----------------------------------------------------------------------------+
// | deep-chat.0.0.1 beta, non stable                                            |
// |                                                                             |
// | deep-chat is free software; you can redistribute it and/or modify           |
// | it under the terms of the GNU Lesser General Public License as published by |
// | the Free Software Foundation; either version 2.0 of the License, or         |
// | (at your option) any later version.                                         |
// |                                                                             |
// | This programm is distributed in the hope that it will be useful,            |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
// | GNU Lesser General Public License for more details.                         |
// |                                                                             |
// | You should have received a copy of the GNU Lesser General Public License    |
// | along with deep-chat; if not, write to the Free Software                    |
// | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                    |
// | 02111-1307 USA                                                              |
// +-----------------------------------------------------------------------------+
// | Author: Nikitin Iliya <deepvarvar@mail.ru>                                  |
// +-----------------------------------------------------------------------------+
//

class chat {

	///////////////////////// CONFIGURATION //////////////////////////

	// Chat directory (Каталог чата)
	protected static $home = "chat/";

	// System data separator - wery need uniq string (Системный разделитель данных - очень нужна уникальная строка)
	protected static $separator = ":::336a09a44395678gfdghjgh5467867987654fde41c75c0294:::";

	// Number of last messages for starting user (Количество последних сообщений для вновь вошедшего пользователя)
	protected static $mshow = 10;

	// Online update interval (Интервал обновления онлайн списка)
	protected static $updinterval = 10; // seconds

	//////////////////////////////////////////////////////////////////

	protected static $locked = false;
	protected static $auth = false;
	protected static $mess = false;

	function init() {
		session_name("deep-chat");
		session_start();
		self::controller();
		}
	function lock() {
		self::$locked = @fopen(realpath(dirname(__FILE__))."/data/lock","w+b");
		if (self::$locked) flock(self::$locked,LOCK_EX);
		}
	function controller() {
		if (isset($_SESSION['cid'])) {
			if (isset($_GET['logout'])) {
				unset($_SESSION['cid']);
				header("Location: /".self::$home);
				die();
				}
			$udata = self::eachUsersData($_SESSION['cid'],false);
			if ($udata) {
				$_SESSION['cid'] = $udata['cid'];
				self::$auth = true;
				if (isset($_POST['l']) and $_POST['l'] > (-1)) {
					self::lock();
					if (isset($_POST['m']))
						$udata += self::eachMessagesData($_POST['l'],self::leadNewMessage($_POST['m'],$udata['name']));
					else $udata += self::eachMessagesData($_POST['l'],false);
					self::unlock();
					self::pubMessages($udata);
					}
				}
			else {
				unset($_SESSION['cid']);
				header("Location: /".self::$home);
				die();
				}
			}
		else {
			if (isset($_POST['nickname']) and trim($_POST['nickname']) != "") {
				$user = self::eachUsersData(false,$_POST['nickname']);
				$_SESSION['cid'] = $user['cid'];
				header("Location: /".self::$home);
				die();
				}
			}
		}
	function headers() {
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0",false);
		header("Pragma: no-cache");
		header("Content-Type: text/html; charset=utf-8");
		header("Server: Hui tebe a ne server");
		header("X-Powered-By: PHP on i v afrike PHP");
		header("Connection: close");
		}
	function pubMessages($data) {
		self::headers();
		die(json_encode($data));
		}
	function eachMessagesData($lm,$m) {
		$messages = realpath(dirname(__FILE__))."/data/chatmessages";
		$mess = "";
		$newdata = "";
		$messagesdata = file($messages);
		$mhide = count($messagesdata) - self::$mshow;
		$mcount = count($messagesdata);
		for ($i = 0; $i <= ($mcount-1); $i++) {
			list($mm['num'],$mm['mess']) = explode(self::$separator,trim($messagesdata[$i]));
			if ($lm <= $mm['num'] and $i > $mhide) {
				$mess .= $mm['mess'];
				$lm = $mm['num']+1;
				}
			$newdata .= $mm['num'].self::$separator.$mm['mess']."\n";
			}
		if ($m) {
			$newdata .= $lm.self::$separator.$m."\n";
			$mess .= $m;
			$lm++;
			file_put_contents($messages,$newdata);
			}
		if ($mess != "") return array("lm" => $lm,"m" => $mess);
		else return array("lm" => $lm);
		}
	function unlock() {
		if (self::$locked) {
			flock(self::$locked,LOCK_UN);
			fclose(self::$locked);
			}
		}
	function getAuth() {
		return self::$auth;
		}
	function getHome() {
		return self::$home;
		}
	function leadNewMessage($m,$user) {
		if(trim($m) != "") {
			$k = mt_rand(0,2);
			$knb = array("Камень","Ножницы","Бумага");
			$replace = "КНБ результат: [<b>".$knb[$k]."</b>]";
			$m = htmlspecialchars($m);

			// hilight code ////////////////////////////////////////
			$m = preg_replace("/(&quot;(.*)&quot;)/","<font color=\"red\">$1</font>",$m,-1);
			$m = preg_replace("/('(.*)')/","<font color=\"red\">$1</font>",$m,-1);
			$m = preg_replace("/(([$]){1,2}([a-z_]{1,32}))/i","<font color=\"blue\">$1</font>",$m,-1);
			////////////////////////////////////////////////////////

			$m = str_replace("\t"," &nbsp;&nbsp;&nbsp;&nbsp;",$m);
			$m = nl2br($m);
			$m = str_replace("\r\n","",$m);
			$m = str_replace("\n\r","",$m);
			$m = str_replace("\r","",$m);
			$m = str_replace("\n","",$m);
			$m = preg_replace("/(\[)(knb)(\])/",$replace,$m,1);
			$m = preg_replace("/(\[)(knb)(\])/","",$m,-1);
			$m = preg_replace("/(\[)([abc]{1,1}[a-z]{1,1}|[d]{1,1}[a-v]{1,1})(\])/","<img src=\"images/smiles/\${2}.gif\" />",$m,-1);
			$m = stripslashes($m);
			if (stristr($m,self::$separator)) $m = str_replace(self::$separator," ...[quoted]... ",$m);
			return "<div class=\"m\">".date("H:i:s")." [<b>$user</b>] -&gt; ".$m."</div>";
			}
		return false;
		}
	function eachUsersData($cid,$new) {
		$im = false;
		$uniq = true;
		$online = "";
		$newdata = "";
		$users = realpath(dirname(__FILE__))."/data/chatusers";
		$usersdata = file($users);
		if ($new) $new = htmlspecialchars(trim($new));
		if (count($usersdata) > 0) {
			foreach ($usersdata as $user) {
				$inlist = true;
				if (trim($user) != "") {
					list($u['cid'],$u['time'],$u['name']) = explode(self::$separator,trim($user));
					if ($cid == $u['cid']) {
						$im = true;
						$u['time'] = time();
						$cid = $u['cid'] = md5(microtime());
						$uname = $u['name'];
						}
					if ((time()-self::$updinterval) > $u['time']) $inlist = false;
					if ($inlist) {
						if ($new and ($new == $u['name'] or $new == "ChatBot")) $uniq = false;
						$online .= "<div>&raquo; <b>".$u['name']."</b></div>";
						$newdata .= $u['cid'].self::$separator.$u['time'].self::$separator.$u['name']."\n";
						}
					}
				}
			if ($cid and !$im) return false;
			}
		if ($new) {
			if (!$uniq) $new = $new."_".mt_rand();
			$cid = md5(microtime());
			$newdata .= $cid.self::$separator.time().self::$separator.$new."\n";
			$online .= "<div>&raquo; <b>$new</b></div>";
			$uname = $new;
			}
		file_put_contents($users,$newdata);
		return array("cid" => $cid,"name" => $uname,"online" => $online);
		}
	}

chat::init();
chat::headers();

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Pragma" content="no-cache" />
<meta http-equiv="Cache-control" content="no-cache" />
<meta http-equiv="content-language" content="ru" />
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<link rel="stylesheet" type="text/css" href="styles/chat.css" media="screen" />
<title> ||| Онлайн Чат ||| </title>
<script type="text/javascript"><?php if (chat::getAuth()) { ?>
var mc = 0;
var l = mc;
var x = true;
var xhr = null;
var v = false;
var sent = false;
var loop;
function createXhr() {
	try {
		xhr = new XMLHttpRequest();
		}
	catch(trymicrosoft) {
		try {
			xhr = new ActiveXObject("Msxm12.XMLHTTP");
			}
		catch(othermicrosoft) {
			try {
				xhr = new ActiveXObject("Microsoft.XMLHTTP");
				}
			catch(failed) {
				xhr = null;
				}
			}
		}
	if(xhr == null) return;
	}
var chat = {
	empty: function() { if (confirm(" Очистить окно истории чата? ")) this.main.innerHTML = ""; },
	view: function(p) {
		var d;
		if (v && p == "") {
			for(var i = 0; i < this.context.length; i++) {
				if (i == 1 || i == 2) d = "block";
				else d = "none";
				this.context[i].style.display = d;
				}
			v = false;
			}
		else {
			for(var i = 0; i < this.context.length; i++) {
				this.context[i].style.display = "none";
				}
			document.getElementById(p).style.display = "block";
			v = true;
			}
		},
	mcte: function() {
			this.mess.focus();
		},
	splace: function(s,t) {
		var r;
		if (t == "com") s = "/" + s + " ";
		else if (t == "bb") s = "[" + s + "]";
		this.mess.value += s;
		this.mcte();
		},
	place: function(d) {
		l = d.lm;
		mc = d.cid;
		this.online.innerHTML = d.online;
		if (typeof d.m != "undefined" && d.m != "") this.main.innerHTML += d.m;
		this.lmh = this.main.lastChild.offsetHeight;
		if (sent) {
			sent = false;
			this.main.scrollTop = this.main.scrollHeight - this.mh;
			}
		else if ((this.main.scrollTop + this.mh + this.lmh) >= this.main.scrollHeight) {
			this.main.scrollTop = this.main.scrollHeight - this.mh;
			}
		x = true;
		},
	request: function() {
		x = false;
		createXhr();
		xhr.open("post",document.location + "?" + Math.random(),true);
		xhr.setRequestHeader("X-Requested-With",mc);
		xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4 && xhr.status == 200) {
				chat.place(eval("(" + xhr.responseText + ")"));
				}
			}
		},
	get: function() {
		x = false;
		this.request();
		xhr.send("l=" + l);
		},
	sendme: function() {
		xhr.abort();
		sent = true;
		this.request();
		xhr.send("l=" + l + "&m=" + encodeURIComponent(this.mess.value));
		this.mcte();
		this.mess.value = "";
		return false;
		},
	init: function() {
		this.main = document.getElementById("main");
		this.mh = this.main.offsetHeight-2;
		this.context = document.getElementById("att").getElementsByClassName("chatcontext");
		this.online = document.getElementById("online");
		this.smiles = document.getElementById("smiles");
		this.mess = document.getElementById("message");
		this.mcte();
		}
	}
function key(event) {
	if((event.keyCode == 13 || event.keyCode == 10) && event.ctrlKey) return chat.sendme();
	}
window.onload = function() {
	chat.init();
	loop = setInterval( function(){
		if (x) {
			chat.get();
			}
		},1000);
	}
<?php } ?></script>
</head>
<body>
<div id="chat">
	<div id="tchat"></div>
	<div id="mainchat">
		<?php if (chat::getAuth()) { ?>
		<div id="main">
		</div>
		<div id="att">
			<div class="chatcontext" id="online" title=" Кликни мышкой чтобы закрыть список " onclick="chat.view('');"></div>
			<div class="chatcontext" id="commands">
				<span title=" Камень, Ножницы, Бумага... " onclick="chat.splace('knb','bb');"> &raquo; КНБ </span>
				<span title=" Список пользователей онлайн " onclick="chat.view('online');"> &raquo; Кто Онлайн? </span>
				<span title=" Очистить окно чата " onclick="chat.empty();"> &raquo; Очистить чат </span>
				<a title=" Выйти из чата " href="?logout"> &raquo; Выход </a>
			</div>
			<div class="chatcontext" id="smiles">
				<span class="smile" onclick="chat.splace('aa','bb');"><img src="images/smiles/aa.gif" /></span>
				<span class="smile" onclick="chat.splace('ab','bb');"><img src="images/smiles/ab.gif" /></span>
				<span class="smile" onclick="chat.splace('ac','bb');"><img src="images/smiles/ac.gif" /></span>
				<span class="smile" onclick="chat.splace('ad','bb');"><img src="images/smiles/ad.gif" /></span>
				<span class="smile" onclick="chat.splace('ae','bb');"><img src="images/smiles/ae.gif" /></span>
				<span class="smile" onclick="chat.splace('af','bb');"><img src="images/smiles/af.gif" /></span>
				<span class="smile" onclick="chat.splace('ag','bb');"><img src="images/smiles/ag.gif" /></span>
				<span class="smile" onclick="chat.splace('ah','bb');"><img src="images/smiles/ah.gif" /></span>
				<span class="smile" onclick="chat.splace('ai','bb');"><img src="images/smiles/ai.gif" /></span>
				<span class="smile" onclick="chat.splace('aj','bb');"><img src="images/smiles/aj.gif" /></span>
				<span class="smile" onclick="chat.splace('ak','bb');"><img src="images/smiles/ak.gif" /></span>
				<span class="smile" onclick="chat.splace('al','bb');"><img src="images/smiles/al.gif" /></span>
				<span class="smile" onclick="chat.splace('am','bb');"><img src="images/smiles/am.gif" /></span>
				<span class="smile" onclick="chat.splace('an','bb');"><img src="images/smiles/an.gif" /></span>
				<span class="smile" onclick="chat.splace('ao','bb');"><img src="images/smiles/ao.gif" /></span>
				<span class="smile" onclick="chat.splace('ap','bb');"><img src="images/smiles/ap.gif" /></span>
				<span class="smile" onclick="chat.splace('aq','bb');"><img src="images/smiles/aq.gif" /></span>
				<span class="smile" onclick="chat.splace('ar','bb');"><img src="images/smiles/ar.gif" /></span>
				<span class="smile" onclick="chat.splace('as','bb');"><img src="images/smiles/as.gif" /></span>
				<span class="smile" onclick="chat.splace('at','bb');"><img src="images/smiles/at.gif" /></span>
				<span class="smile" onclick="chat.splace('au','bb');"><img src="images/smiles/au.gif" /></span>
				<span class="smile" onclick="chat.splace('av','bb');"><img src="images/smiles/av.gif" /></span>
				<span class="smile" onclick="chat.splace('aw','bb');"><img src="images/smiles/aw.gif" /></span>
				<span class="smile" onclick="chat.splace('ax','bb');"><img src="images/smiles/ax.gif" /></span>
				<span class="smile" onclick="chat.splace('ay','bb');"><img src="images/smiles/ay.gif" /></span>
				<span class="smile" onclick="chat.splace('az','bb');"><img src="images/smiles/az.gif" /></span>
			</div>
		</div>
		<div class="clear"></div>
		<div id="write">
			<form action="http://google.com/" method="post" onsubmit="return false;">
				<div><sub>Отправить сообщение: Ctrl+Enter</sub></div>
				<textarea class="rf" id="message" rows="1" cols="52" onkeypress="return key(event);"></textarea>
				<input id="send" type="button" onclick="chat.sendme();" />
			</form>
		</div>
		<?php } else { ?>
		<div id="welcome">
			<form action="<?=$_SERVER['REQUEST_URI']?>" method="post">
				Назови себя:&nbsp;&nbsp;&nbsp;&nbsp;
				<input type="text" class="rf" name="nickname" value="" />&nbsp;&nbsp;&nbsp;&nbsp;
				<input id="gochat" type="submit" value=" ..и входи " />
			</form>
		</div>
		<?php } ?>
	</div>
	<div id="bchat"></div>
	<div id="copyleft">&copy; aka Copyleft 2011. Engine by Deep, design by <a target="_blank" href="http://www.kashoobazz.com/">KASHOOBAZz</a>.</div>
</div>
</body>
</html>
